Index: /branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Transformers/Transformers.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Transformers/Transformers.cs	(revision 15508)
+++ /branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Transformers/Transformers.cs	(revision 15509)
@@ -600,478 +894,131 @@
       return obj;
     }
-  }
-  #endregion
-
-  #region Tuple
-  [Transformer("63A19D57-EEEF-4346-9F06-B35B15EBFFA3", 221)]
-  [StorableType("ab537f25-dc21-4585-b743-0350a5cf1e54")]
-  internal sealed class TupleTransformer : Transformer {
-    private static readonly HashSet<Type> supportedTypes = new HashSet<Type> {
-      typeof(Tuple<>), typeof(Tuple<,>), typeof(Tuple<,,>), typeof(Tuple<,,,>),
-      typeof(Tuple<,,,,>), typeof(Tuple<,,,,,>), typeof(Tuple<,,,,,,>), typeof(Tuple<,,,,,,,>)
-    };
+
+  }
+
+  [Transformer("78556C88-0FEE-4602-95C7-A469B2DDB468", 600)]
+  [StorableType("3A578289-43CA-40F8-9F1E-2BDD255CB8FB")]
+  internal sealed class StorableTypeBoxTransformer : BoxTransformer<object> {
     public override bool CanTransformType(Type type) {
-      return type.IsGenericType && supportedTypes.Contains(type.GetGenericTypeDefinition());
-    }
-    public override Box ToBox(object o, Mapper mapper) {
-      var box = Box.CreateBuilder();
-      box.TransformerId = mapper.GetTransformerId(this);
-      Populate(box, o, mapper);
-      return box.Build();
-    }
-    private void Populate(Box.Builder box, object value, Mapper mapper) {
+      return StorableTypeAttribute.IsStorableType(type) && !type.IsValueType && !type.IsEnum || // don't transform structs or enums
+        type.BaseType != null && CanTransformType(type.BaseType);
+    }
+
+    protected override void Populate(Box box, object value, Mapper mapper) {
+      var b = new StorableClassBox();
       var type = value.GetType();
-      var uIntArrayBox = UnsignedIntArrayBox.CreateBuilder();
-      for (int i = 1; i <= type.GetGenericArguments().Length; i++) {
-        string name = string.Format("Item{0}", i);
-        uIntArrayBox.AddValues(mapper.GetBoxId(type.GetProperty(name).GetValue(value)));
-      }
-      box.TypeId = mapper.GetBoxId(type);
-      box.SetExtension(UnsignedIntArrayBox.UnsignedIntArray, uIntArrayBox.Build());
-    }
-    public override object ToObject(Box box, Mapper mapper) {
-      var type = (Type)mapper.GetObject(box.TypeId);
-      var defaultValues = type.GetGenericArguments().Select(x =>
-        x.IsValueType ? Activator.CreateInstance(x) : null
-      ).ToArray();
-      return Activator.CreateInstance(type, defaultValues);
-    }
+      var typeInfo = Mapper.StaticCache.GetTypeInfo(type);
+
+      var emptyArgs = new object[0];
+      foreach (var hook in typeInfo.BeforeSerializationHooks) {
+        hook.Invoke(value, emptyArgs);
+      }
+
+      var components = new Dictionary<uint, uint>();
+      foreach (var componentInfo in typeInfo.Fields) {
+        var field = (FieldInfo)componentInfo.MemberInfo;
+        var component = mapper.GetBoxId(field.GetValue(value));
+        components.Add(mapper.GetStringId(componentInfo.Name), component);
+      }
+
+      foreach (var componentInfo in typeInfo.Properties.Where(x => x.Readable)) {
+        var property = (PropertyInfo)componentInfo.MemberInfo;
+        var component = mapper.GetBoxId(property.GetValue(value, null));
+        components.Add(mapper.GetStringId(componentInfo.Name), component);
+      }
+
+      foreach (var component in components) {
+        b.KeyValuePairs.Add(component.Key, component.Value);
+      }
+
+      box.BoxId = mapper.GetStorableClassBoxId(b);
+    }
+
+    protected override object Extract(Box box, Type type, Mapper mapper) {
+      return mapper.CreateInstance(type);
+    }
+
     public override void FillFromBox(object obj, Box box, Mapper mapper) {
-      var uIntArrayBox = box.GetExtension(UnsignedIntArrayBox.UnsignedIntArray);
-      var elements = uIntArrayBox.ValuesList.Select(mapper.GetObject).ToArray();
+      var data = mapper.GetStorableClassBox(box.BoxId);
       var type = obj.GetType();
-      for (int i = 1; i <= elements.Length; i++) {
-        string name = string.Format("m_Item{0}", i);
-        DataMemberAccessor.GenerateFieldSetter(type.GetField(name, BindingFlags.NonPublic | BindingFlags.Instance))(obj, elements[i - 1]);
-      }
-    }
-  }
-  #endregion
-
-  #region Bitmap
-  [Transformer("D0ADB806-2DFD-459D-B5DA-14B5F1152534", 222)]
-  [StorableType("b13d6153-e71d-4b76-9893-81d3570403e8")]
-  internal sealed class BitmapTransformer : ByteArrayBoxTransformer<Bitmap> {
-    protected override ByteString ToByteString(Bitmap value) {
-      lock (value)
-        using (var ms = new MemoryStream()) {
-          value.Save(ms, ImageFormat.Png);
-          return ByteString.CopyFrom(ms.ToArray());
+      var typeInfo = Mapper.StaticCache.GetTypeInfo(type);
+      var typeBox = mapper.GetTypeBox(mapper.GetBox(box.TypeId).BoxId);
+      var version = Math.Max(typeBox.Version, 1);
+      var typeGuid = typeInfo.StorableTypeAttribute.Guid;
+
+      var components = new Dictionary<uint, uint>();
+      foreach (var kvp in data.KeyValuePairs) {
+        components.Add(kvp.Key, kvp.Value);
+      }
+
+      var conversionMethods =
+        type.Assembly.GetTypes().SelectMany(t =>
+          t.GetMethods(BindingFlags.NonPublic | BindingFlags.Static)
+          .Where(StorableConversionAttribute.IsStorableConversionMethod)
+          .Where(mi => StorableConversionAttribute.GetGuid(mi) == typeGuid &&
+                       StorableConversionAttribute.GetVersion(mi) >= version))
+          .OrderBy(StorableConversionAttribute.GetVersion)
+          .ToArray();
+
+      // put all objects into dictionary for conversion 
+      var dict = new Dictionary<string, object>();
+      foreach (var component in components) {
+        dict.Add(mapper.GetString(component.Key), mapper.GetObject(component.Value));
+      }
+
+      Dictionary<string, object> lastDict = new Dictionary<string, object>();
+      foreach (var convMeth in conversionMethods) {
+        if (StorableConversionAttribute.GetVersion(convMeth) != version)
+          throw new PersistenceException(string.Format("No conversion method defined for type {0} version {1}", typeGuid, version));
+        lastDict = (Dictionary<string, object>)convMeth.Invoke(null, new object[] { dict });
+        foreach (var kvp in lastDict) {
+          dict[kvp.Key] = kvp.Value;
         }
-    }
-    protected override Bitmap FromByteString(ByteString byteString) {
-      using (var ms = new MemoryStream()) {
-        ms.Write(byteString.ToArray(), 0, byteString.Length);
-        ms.Seek(0, SeekOrigin.Begin);
-        return new Bitmap(ms);
-      }
-    }
-  }
-  #endregion
-
-  #region Font
-  [Transformer("AFF27987-3301-4D70-9601-EFCA31BDA0DB", 223)]
-  [StorableType("b9f9a371-4dcb-478b-b0d4-6f87a15c02b5")]
-  internal sealed class FontTransformer : UnsignedIntArrayBoxTransformer<Font> {
-
-    protected override IEnumerable<uint> ToBoxType(Font value, Mapper mapper) {
-      yield return mapper.GetStringId(GetFontFamilyName(value.FontFamily));
-      yield return mapper.GetBoxId(value.Size);
-      yield return mapper.GetBoxId(value.Style);
-      yield return mapper.GetBoxId(value.Unit);
-      yield return mapper.GetBoxId(value.GdiCharSet);
-      yield return mapper.GetBoxId(value.GdiVerticalFont);
-    }
-    protected override Font ToValueType(IEnumerable<uint> value, Type type, Mapper mapper) {
-      var fontData = value.ToArray();
-      return new Font(
-        GetFontFamily(mapper.GetString(fontData[0])),
-        (float)mapper.GetObject(fontData[1]),
-        (FontStyle)mapper.GetObject(fontData[2]),
-        (GraphicsUnit)mapper.GetObject(fontData[3]),
-        (byte)mapper.GetObject(fontData[4]),
-        (bool)mapper.GetObject(fontData[5])
-      );
-    }
-
-    public const string GENERIC_MONOSPACE_NAME = "_GenericMonospace";
-    public const string GENERIC_SANS_SERIF_NAME = "_GenericSansSerif";
-    public const string GENERIC_SERIF_NAME = "_GenericSerif";
-
-    public static FontFamily GetFontFamily(string name) {
-      if (name == GENERIC_MONOSPACE_NAME) return FontFamily.GenericMonospace;
-      if (name == GENERIC_SANS_SERIF_NAME) return FontFamily.GenericSansSerif;
-      if (name == GENERIC_SERIF_NAME) return FontFamily.GenericSerif;
-      return new FontFamily(name);
-    }
-
-    public static string GetFontFamilyName(FontFamily ff) {
-      if (ff.Equals(FontFamily.GenericMonospace)) return GENERIC_MONOSPACE_NAME;
-      if (ff.Equals(FontFamily.GenericSansSerif)) return GENERIC_SANS_SERIF_NAME;
-      if (ff.Equals(FontFamily.GenericSerif)) return GENERIC_SERIF_NAME;
-      return ff.Name;
-    }
-  }
-  #endregion
-
-  #region Array Types
-  [Transformer("FF89F6D1-CDE3-498E-9166-F70AC6EB01F1", 301)]
-  [StorableType("59d8363a-7e6c-4d29-9432-8274acd2145f")]
-  internal sealed class ByteArrayTransformer : ByteArrayBoxTransformer<byte[]> {
-    protected override ByteString ToByteString(byte[] value) {
-      return ByteString.CopyFrom(value);
-    }
-    protected override byte[] FromByteString(ByteString byteString) {
-      return byteString.ToArray();
-    }
-  }
-
-  [Transformer("B49B3F2D-2E97-4BAB-8705-8D29DA707C6A", 302)]
-  [StorableType("304c7463-4575-481b-8922-6a54957305c7")]
-  internal sealed class SByteArrayTransformer : ByteArrayBoxTransformer<sbyte[]> {
-    protected override ByteString ToByteString(sbyte[] value) {
-      return ByteString.CopyFrom(value.Select(b => (byte)b).ToArray());
-    }
-    protected override sbyte[] FromByteString(ByteString byteString) {
-      return byteString.Select(b => (sbyte)b).ToArray();
-    }
-  }
-
-  [Transformer("F25A73B2-6B67-4493-BD59-B836AF4455D1", 300)]
-  [StorableType("06fdb68c-ec5e-4cb5-9ad1-063fca0b9c2e")]
-  internal sealed class BoolArrayTransformer : BoolArrayBoxTransformer<bool[]> {
-    protected override IEnumerable<bool> ToBoxType(bool[] value, Mapper mapper) { return value; }
-    protected override bool[] ToValueType(IEnumerable<bool> value, Type type, Mapper mapper) { return value.ToArray(); }
-  }
-
-  [Transformer("2811FDD4-6800-4CBA-86D7-9071ED5775ED", 303)]
-  [StorableType("832d8971-51b1-4264-b7eb-07d6e836bf7b")]
-  internal sealed class ShortArrayTransformer : ByteArrayBoxTransformer<short[]> {
-    protected override ByteString ToByteString(short[] value) {
-      var res = new byte[value.Length * 2];
-      for (int i = 0; i < value.Length; i++) {
-        var bytes = BitConverter.GetBytes(value[i]);
-        Array.Copy(bytes, 0, res, i * 2, 2);
-      }
-      return ByteString.CopyFrom(res);
-    }
-    protected override short[] FromByteString(ByteString byteString) {
-      var bytes = byteString.ToArray();
-      var res = new short[bytes.Length / 2];
-      for (int i = 0; i < bytes.Length; i += 2) {
-        res[i / 2] = BitConverter.ToInt16(bytes, i);
-      }
-      return res;
-    }
-  }
-
-  [Transformer("1AAC2625-356C-40BC-8CB4-15CB3D047EB8", 304)]
-  [StorableType("c303b4cf-ffd0-47e2-9d94-07f2d558d17f")]
-  internal sealed class UShortArrayTransformer : ByteArrayBoxTransformer<ushort[]> {
-    protected override ByteString ToByteString(ushort[] value) {
-      var res = new byte[value.Length * 2];
-      for (int i = 0; i < value.Length; i++) {
-        var bytes = BitConverter.GetBytes(value[i]);
-        Array.Copy(bytes, 0, res, i * 2, 2);
-      }
-      return ByteString.CopyFrom(res);
-    }
-    protected override ushort[] FromByteString(ByteString byteString) {
-      var bytes = byteString.ToArray();
-      var res = new ushort[bytes.Length / 2];
-      for (int i = 0; i < bytes.Length; i += 2) {
-        res[i / 2] = BitConverter.ToUInt16(bytes, i);
-      }
-      return res;
-    }
-  }
-
-  [Transformer("12F19098-5D49-4C23-8897-69087F1C146D", 305)]
-  [StorableType("55f7c8b0-f2aa-4830-857d-6ce2807da138")]
-  internal sealed class CharArrayTransformer : ByteArrayBoxTransformer<char[]> {
-    protected override ByteString ToByteString(char[] value) {
-      var res = new byte[value.Length * 2];
-      for (int i = 0; i < value.Length; i++) {
-        var bytes = BitConverter.GetBytes(value[i]);
-        Array.Copy(bytes, 0, res, i * 2, 2);
-      }
-      return ByteString.CopyFrom(res);
-    }
-    protected override char[] FromByteString(ByteString byteString) {
-      var bytes = byteString.ToArray();
-      var res = new char[bytes.Length / 2];
-      for (int i = 0; i < bytes.Length; i += 2) {
-        res[i / 2] = BitConverter.ToChar(bytes, i);
-      }
-      return res;
-    }
-  }
-
-  [Transformer("5F6DC3BC-4433-4AE9-A636-4BD126F7DACD", 306)]
-  [StorableType("e7089621-5236-4d37-a592-c8a0816c59fa")]
-  internal sealed class IntArrayTransformer : IntArrayBoxTransformer<int[]> {
-    protected override IEnumerable<int> ToBoxType(int[] value, Mapper mapper) { return value; }
-    protected override int[] ToValueType(IEnumerable<int> value, Type type, Mapper mapper) { return value.ToArray(); }
-  }
-
-  [Transformer("3F10274F-D350-4C82-89EA-A5EB36D4EFCC", 307)]
-  [StorableType("0972d235-5e21-4abf-84f8-aad1bbfdff40")]
-  internal sealed class UIntArrayTransformer : UnsignedIntArrayBoxTransformer<uint[]> {
-    protected override IEnumerable<uint> ToBoxType(uint[] value, Mapper mapper) { return value; }
-    protected override uint[] ToValueType(IEnumerable<uint> value, Type type, Mapper mapper) { return value.ToArray(); }
-  }
-
-  [Transformer("E9D550E2-57F7-47F3-803D-37A619DA1A5C", 308)]
-  [StorableType("0c656d5d-11dc-4a75-895a-06701048cd70")]
-  internal sealed class LongArrayTransformer : LongArrayBoxTransformer<long[]> {
-    protected override IEnumerable<long> ToBoxType(long[] value, Mapper mapper) { return value; }
-    protected override long[] ToValueType(IEnumerable<long> value, Type type, Mapper mapper) { return value.ToArray(); }
-  }
-
-  [Transformer("C02A205B-2176-4282-AC2B-ADEF96DDBE24", 309)]
-  [StorableType("c5f87514-a6c1-400b-9a6c-8adcf980f701")]
-  internal sealed class ULongArrayTransformer : UnsignedLongArrayBoxTransformer<ulong[]> {
-    protected override IEnumerable<ulong> ToBoxType(ulong[] value, Mapper mapper) { return value; }
-    protected override ulong[] ToValueType(IEnumerable<ulong> value, Type type, Mapper mapper) { return value.ToArray(); }
-  }
-
-  [Transformer("3C4590D9-C76E-4AFB-98FD-E50D3D051648", 310)]
-  [StorableType("ecc63624-1b78-4bef-8326-74c1a43078ff")]
-  internal sealed class FloatArrayTransformer : FloatArrayBoxTransformer<float[]> {
-    protected override IEnumerable<float> ToBoxType(float[] value, Mapper mapper) { return value; }
-    protected override float[] ToValueType(IEnumerable<float> value, Type type, Mapper mapper) { return value.ToArray(); }
-  }
-
-  [Transformer("FB98C399-9323-4470-9A85-9186C2B2D5D4", 311)]
-  [StorableType("03025baa-f57a-48de-b0e2-8e6dc10740ee")]
-  internal sealed class DoubleArrayTransformer : DoubleArrayBoxTransformer<double[]> {
-    protected override IEnumerable<double> ToBoxType(double[] value, Mapper mapper) { return value; }
-    protected override double[] ToValueType(IEnumerable<double> value, Type type, Mapper mapper) { return value.ToArray(); }
-  }
-
-  [Transformer("68332513-9CF1-47FA-A093-6DDB663186EC", 312)]
-  [StorableType("791ea34d-e071-4ef2-812b-eb8e2faced45")]
-  internal sealed class StringArrayTransformer : StringArrayBoxTransformer<string[]> {
-    protected override IEnumerable<string> ToBoxType(string[] value, Mapper mapper) { return value; }
-    protected override string[] ToValueType(IEnumerable<string> value, Type type, Mapper mapper) { return value.ToArray(); }
-  }
-
-  [Transformer("B01ADF0A-ACAA-444E-9F82-0C7C2AF1F490", 400)]
-  [StorableType("56ae4f46-9fc1-4243-a07f-7b7c24e30545")]
-  internal sealed class ArrayTransformer : Transformer {
-    public override bool CanTransformType(Type type) {
-      return type.IsArray;
-    }
-    public override Box ToBox(object o, Mapper mapper) {
-      var box = Box.CreateBuilder();
-      box.TransformerId = mapper.GetTransformerId(this);
-      Populate(box, o, mapper);
-      return box.Build();
-    }
-    private void Populate(Box.Builder box, object value, Mapper mapper) {
-      var type = value.GetType();
-      var array = (Array)value;
-      var rank = array.Rank;
-
-      var uIntArrayBox = UnsignedIntArrayBox.CreateBuilder();
-      uIntArrayBox.AddValues(mapper.GetBoxId(rank));
-
-      int[] lengths = new int[rank];
-      int[] lowerBounds = new int[rank];
-      for (int i = 0; i < rank; i++) {
-        lengths[i] = array.GetLength(i);
-        lowerBounds[i] = array.GetLowerBound(i);
-      }
-
-      uIntArrayBox.AddRangeValues(lengths.Select(x => mapper.GetBoxId(x)));
-      uIntArrayBox.AddRangeValues(lowerBounds.Select(x => mapper.GetBoxId(x)));
-
-      int[] positions = (int[])lowerBounds.Clone();
-      while (positions[rank - 1] < lengths[rank - 1] + lowerBounds[rank - 1]) {
-        uIntArrayBox.AddValues(mapper.GetBoxId(array.GetValue(positions)));
-        positions[0] += 1;
-        for (int i = 0; i < rank - 1; i++) {
-          if (positions[i] >= lowerBounds[i] + lengths[i]) {
-            positions[i] = lowerBounds[i];
-            positions[i + 1] += 1;
-          } else {
-            break;
-          }
+        version++;
+      }
+      if (version != typeInfo.StorableTypeAttribute.Version)
+        throw new PersistenceException(string.Format("Missing one or more conversion methods for type {0} version {1}",
+          typeGuid, typeInfo.StorableTypeAttribute.Version));
+
+      // set default values for all fields and properties
+      foreach (var componentInfo in typeInfo.Fields) {
+        var field = (FieldInfo)componentInfo.MemberInfo;
+        if (componentInfo.StorableAttribute != null && componentInfo.StorableAttribute.DefaultValue != null)
+          field.SetValue(obj, componentInfo.StorableAttribute.DefaultValue);
+      }
+      foreach (var componentInfo in typeInfo.Properties.Where(x => x.Writeable)) {
+        var property = (PropertyInfo)componentInfo.MemberInfo;
+        if (componentInfo.StorableAttribute != null && componentInfo.StorableAttribute.DefaultValue != null)
+          property.SetValue(obj, componentInfo.StorableAttribute.DefaultValue, null);
+      }
+
+      // set all members as generated by conversion method chain
+      foreach (var kvp in dict) {
+        var key = kvp.Key;
+        var val = kvp.Value;
+        var fieldInfo = typeInfo.Fields.FirstOrDefault(fi => fi.Name == key);
+        if (fieldInfo != null) {
+          var field = (FieldInfo)fieldInfo.MemberInfo;
+          field.SetValue(obj, val);
+          lastDict.Remove(fieldInfo.Name); // only for consistency check
+          continue;
         }
-      }
-
-      box.TypeId = mapper.GetBoxId(type);
-      box.SetExtension(UnsignedIntArrayBox.UnsignedIntArray, uIntArrayBox.Build());
-    }
-    public override object ToObject(Box box, Mapper mapper) {
-      var uIntArrayBox = box.GetExtension(UnsignedIntArrayBox.UnsignedIntArray);
-      var rank = (int)mapper.GetObject(uIntArrayBox.GetValues(0));
-
-      int[] lengths = new int[rank], lowerBounds = new int[rank];
-      for (int i = 0; i < rank; i++)
-        lengths[i] = (int)mapper.GetObject(uIntArrayBox.GetValues(i + 1));
-      for (int i = 0; i < rank; i++)
-        lowerBounds[i] = (int)mapper.GetObject(uIntArrayBox.GetValues(i + 1 + rank));
-
-      var type = (Type)mapper.GetObject(box.TypeId);
-      return Array.CreateInstance(type.GetElementType(), lengths, lowerBounds);
-    }
-    public override void FillFromBox(object obj, Box box, Mapper mapper) {
-      var array = (Array)obj;
-      var uIntArrayBox = box.GetExtension(UnsignedIntArrayBox.UnsignedIntArray);
-      var rank = (int)mapper.GetObject(uIntArrayBox.GetValues(0));
-
-      int[] lengths = new int[rank], lowerBounds = new int[rank];
-      for (int i = 0; i < rank; i++)
-        lengths[i] = (int)mapper.GetObject(uIntArrayBox.GetValues(i + 1));
-      for (int i = 0; i < rank; i++)
-        lowerBounds[i] = (int)mapper.GetObject(uIntArrayBox.GetValues(i + 1 + rank));
-
-      int[] positions = (int[])lowerBounds.Clone();
-      var e = uIntArrayBox.ValuesList.Skip(1 + 2 * rank).GetEnumerator();
-      while (e.MoveNext()) {
-        int[] currentPositions = positions;
-        array.SetValue(mapper.GetObject(e.Current), currentPositions);
-        positions[0] += 1;
-        for (int i = 0; i < rank - 1; i++) {
-          if (positions[i] >= lengths[i] + lowerBounds[i]) {
-            positions[i] = lowerBounds[i];
-            positions[i + 1] += 1;
-          } else {
-            break;
-          }
+        var propInfo = typeInfo.Properties.Where(x => x.Writeable).FirstOrDefault(pi => pi.Name == key);
+        if (propInfo != null) {
+          var prop = (PropertyInfo)propInfo.MemberInfo;
+          prop.SetValue(obj, val, null);
+          lastDict.Remove(propInfo.Name);    // only for consistency check
+          continue;
         }
       }
-    }
-  }
-  #endregion
-
-  [Transformer("4FA5EAAF-ECC7-4A9C-84E7-6583DA96F3B9", 500)]
-  [StorableType("b19c0fe5-6bba-4492-af91-c111edce77dc")]
-  internal sealed class EnumerableTransformer : Transformer {
-    private static readonly HashSet<Type> supportedTypes = new HashSet<Type> {
-      typeof(Stack<>), typeof(Stack),
-      typeof(Queue<>), typeof(Queue),
-      typeof(HashSet<>),
-      typeof(List<>), typeof(ArrayList)
-    };
-    public override bool CanTransformType(Type type) {
-      return type.IsGenericType && supportedTypes.Contains(type.GetGenericTypeDefinition()) || supportedTypes.Contains(type);
-    }
-    public override Box ToBox(object o, Mapper mapper) {
-      var box = Box.CreateBuilder();
-      box.TransformerId = mapper.GetTransformerId(this);
-      Populate(box, o, mapper);
-      return box.Build();
-    }
-    private void Populate(Box.Builder box, object value, Mapper mapper) {
-      var uIntArrayBox = UnsignedIntArrayBox.CreateBuilder();
-
-      var type = value.GetType();
-      var propertyInfo = type.GetProperty("Comparer");
-      if (propertyInfo != null) {
-        // TODO: where to store id for comparer box? (atm: first element in int array ...)
-        var comparer = propertyInfo.GetValue(value);
-        var comparerType = comparer.GetType();
-        if (StorableTypeAttribute.IsStorableType(comparerType))
-          uIntArrayBox.AddValues(mapper.GetBoxId(comparer));
-        else if (comparerType.GetFields(BindingFlags.Instance | BindingFlags.Public | BindingFlags.NonPublic | BindingFlags.FlattenHierarchy).Any())
-          throw new NotSupportedException("Cannot serialize non-storable equality comparers with fields");
-        else
-          uIntArrayBox.AddValues(mapper.GetBoxId(comparerType));
-      }
-
-      foreach (var item in (IEnumerable)value)
-        uIntArrayBox.AddValues(mapper.GetBoxId(item));
-
-      box.TypeId = mapper.GetBoxId(type);
-      box.SetExtension(UnsignedIntArrayBox.UnsignedIntArray, uIntArrayBox.Build());
-    }
-    public override object ToObject(Box box, Mapper mapper) {
-      var uIntArrayBox = box.GetExtension(UnsignedIntArrayBox.UnsignedIntArray);
-      var type = (Type)mapper.GetObject(box.TypeId);
-      return Activator.CreateInstance(type);
-    }
-    public override void FillFromBox(object obj, Box box, Mapper mapper) {
-      var uIntArrayBox = box.GetExtension(UnsignedIntArrayBox.UnsignedIntArray);
-      var elements = uIntArrayBox.ValuesList.Select(mapper.GetObject);
-      var type = obj.GetType();
-
-      string methodName = string.Empty;
-      if (type.IsGenericType && type.GetGenericTypeDefinition() == typeof(Stack<>) || type == typeof(Stack)) {
-        elements = elements.Reverse();
-        methodName = "Push";
-      } else if (type.IsGenericType && type.GetGenericTypeDefinition() == typeof(Queue<>) || type == typeof(Queue)) {
-        methodName = "Enqueue";
-      } else {
-        methodName = "Add";
-        if (type.IsGenericType && type.GetGenericTypeDefinition() == typeof(HashSet<>)) {
-          var fieldInfo = type.GetField("m_comparer", BindingFlags.NonPublic | BindingFlags.Instance);
-          var comparerObj = mapper.GetObject(uIntArrayBox.GetValues(0));
-          var comparer = comparerObj is Type ? Activator.CreateInstance((Type)comparerObj) : comparerObj;
-          fieldInfo.SetValue(obj, comparer);
-          elements = elements.Skip(1);
-        }
-      }
-
-      MethodInfo addMethod = type.GetMethod(methodName);
-      foreach (var e in elements)
-        addMethod.Invoke(obj, new[] { e });
-    }
-  }
-
-  [Transformer("C47A62F5-F113-4A43-A8EE-CF817EC799A2", 501)]
-  [StorableType("ba53df84-dc97-4d8d-a493-868972ed1002")]
-  internal sealed class DictionaryTransformer : Transformer {
-    public override bool CanTransformType(Type type) {
-      return type.IsGenericType && typeof(Dictionary<,>) == type.GetGenericTypeDefinition();
-    }
-    public override Box ToBox(object o, Mapper mapper) {
-      var box = Box.CreateBuilder();
-      box.TransformerId = mapper.GetTransformerId(this);
-      Populate(box, o, mapper);
-      return box.Build();
-    }
-    private void Populate(Box.Builder box, object value, Mapper mapper) {
-      var dictionaryBox = DictionaryBox.CreateBuilder();
-      foreach (DictionaryEntry item in (IDictionary)value) {
-        dictionaryBox.AddKeyIds(mapper.GetBoxId(item.Key));
-        dictionaryBox.AddValueIds(mapper.GetBoxId(item.Value));
-      }
-
-      var type = value.GetType();
-      var propertyInfo = type.GetProperty("Comparer");
-      var comparer = propertyInfo.GetValue(value);
-
-      var comparerType = comparer.GetType();
-      if (StorableTypeAttribute.IsStorableType(comparerType))
-        dictionaryBox.SetComparerId(mapper.GetBoxId(comparer));
-      else if (comparerType.GetFields(BindingFlags.Instance | BindingFlags.Public | BindingFlags.NonPublic | BindingFlags.FlattenHierarchy).Any())
-        throw new NotSupportedException("Cannot serialize non-storable equality comparers with fields");
-      else
-        dictionaryBox.SetComparerId(mapper.GetBoxId(comparerType));
-
-      box.TypeId = mapper.GetBoxId(type);
-      box.SetExtension(DictionaryBox.Dictionary, dictionaryBox.Build());
-    }
-    public override object ToObject(Box box, Mapper mapper) {
-      var dictionaryBox = box.GetExtension(DictionaryBox.Dictionary);
-      return Activator.CreateInstance((Type)mapper.GetObject(box.TypeId), dictionaryBox.ValueIdsCount);
-    }
-    public override void FillFromBox(object obj, Box box, Mapper mapper) {
-      var type = obj.GetType();
-      var dictionaryBox = box.GetExtension(DictionaryBox.Dictionary);
-      var comparerObj = mapper.GetObject(dictionaryBox.ComparerId);
-      var comparer = comparerObj is Type ? Activator.CreateInstance((Type)comparerObj) : comparerObj;
-
-      var fieldInfo = type.GetField("comparer", BindingFlags.NonPublic | BindingFlags.Instance);
-      fieldInfo.SetValue(obj, comparer);
-
-
-      var addMethod = type.GetMethod("Add");
-      for (int i = 0; i < dictionaryBox.KeyIdsCount; i++) {
-        var key = mapper.GetObject(dictionaryBox.GetKeyIds(i));
-        var value = mapper.GetObject(dictionaryBox.GetValueIds(i));
-        addMethod.Invoke(obj, new[] { key, value });
+
+      if (lastDict.Any())
+        throw new PersistenceException(string.Format("Invalid conversion method. The following members are undefined in type {0} version {1}: {2}",
+          typeGuid, typeInfo.StorableTypeAttribute.Version,
+          string.Join(", ", lastDict.Keys)));
+
+      var emptyArgs = new object[0];
+      foreach (var hook in typeInfo.AfterDeserializationHooks) {
+        hook.Invoke(obj, emptyArgs);
       }
     }
Index: /branches/PersistenceReintegration/HeuristicLab.Tests/HeuristicLab.Persistence-3.3/UseCasesPersistenceNew.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Tests/HeuristicLab.Persistence-3.3/UseCasesPersistenceNew.cs	(revision 15508)
+++ /branches/PersistenceReintegration/HeuristicLab.Tests/HeuristicLab.Persistence-3.3/UseCasesPersistenceNew.cs	(revision 15509)
@@ -30,8 +30,6 @@
 using System.Reflection;
 using System.Text;
-using System.Threading;
 using System.Threading.Tasks;
 using HeuristicLab.Algorithms.GeneticAlgorithm;
-using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
@@ -39,5 +37,4 @@
 using HeuristicLab.Persistence.Auxiliary;
 using HeuristicLab.Persistence.Core;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Persistence.Default.DebugString;
 using HeuristicLab.Persistence.Default.Xml;
@@ -2210,5 +2207,5 @@
 
       [Storable(Name = "s", AllowOneWay = true)]
-      public string StorableString {  set { PublicString = value; } }
+      public string StorableString { set { PublicString = value; } }
       public string PublicString { get; set; }
     }
@@ -2284,5 +2281,5 @@
       var restored = (V3)o;
       Assert.AreEqual(restored.a, old.a.Value);
-      Assert.IsTrue(restored.val.SequenceEqual(old.vals.Select(iv=>iv.Value)));
+      Assert.IsTrue(restored.val.SequenceEqual(old.vals.Select(iv => iv.Value)));
       Assert.IsTrue(restored.items.Select(item => item.Value).SequenceEqual(old.items.Select(iv => (double)((dynamic)iv).Value)));
       // Assert.AreSame(restored.items[0], restored.items[1]);
@@ -2327,5 +2324,5 @@
     [TestProperty("Time", "short")]
     public void TestLoadingSamples() {
-      var path = @"D:\hl\branches\PersistenceReintegration\HeuristicLab.Optimizer\3.3\Documents";
+      var path = @"D:\Dev\Software_HL\branches\PersistenceReintegration\HeuristicLab.Optimizer\3.3\Documents";
       var serializer = new ProtoBufSerializer();
       foreach (var fileName in Directory.EnumerateFiles(path, "*.hl")) {
@@ -2351,4 +2348,5 @@
           serializer.Serialize(original, fileName + ".proto");
           // var newVersion = serializer.Deserialize(fileName + ".proto");
+          Console.WriteLine("File: " + fileName);
           var p = Profile(() => original);
           Console.WriteLine(p);
